package net.sf.jcc.model.parser.uml2;

import java.util.HashMap;
import java.util.Map;

import net.sf.jcc.model.parser.InternalStore;
import net.sf.jcc.model.parser.TransformationResult;


public class ElementStore implements InternalStore<ModelElement> 
{
	private Map<String, ModelElement> store = new HashMap<String, ModelElement>();
	private Map<Object, ModelElement> reverse = new HashMap<Object, ModelElement>();
	
	@Override
	public void store(ModelElement value) 
	{
		store.put(value.getGuid(), value);
		reverse.put(value.getElement(), value);
	}

	@Override
	public void export(TransformationResult transformationResult) 
	{
		if (transformationResult instanceof StoreTransformationResult)
		{
			((StoreTransformationResult)transformationResult).setExportedFile(this);
		}
	}

	public ModelElement get(String guid)
	{
		return store.get(guid);
	}
	
	public ModelElement reverse(Object element)
	{
		return reverse.get(element);
	}
	
	@Override
	public void close() 
	{
	}

}
