package net.sf.jcc.model.parser.uml2;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.xml.namespace.QName;

public class ModelElement 
{
	private String guid;
	private Object element;
	private Object extension;
	private Map<QName, List<String>> references;
	
	public ModelElement(String guid, Object element)
	{
		this.guid = guid;
		this.element = element;
		references = new HashMap<QName, List<String>>();
	}
	
	public String getGuid() 
	{
		return guid;
	}
	
	public Object getElement() 
	{
		return element;
	}

	public void addReference(QName name, String ref) 
	{
		List<String> refs = references.get(name);
		if (refs == null)
		{
			refs = new ArrayList<String>();
			references.put(name, refs);
		}
		refs.add(ref);
	}
	
	public Iterator<QName> references()
	{
		return references.keySet().iterator();
	}
	
	public String getReference(QName qname)
	{
		List<String> refs = references.get(qname);
		if (refs == null || refs.isEmpty())
		{
			return null;
		}
		return refs.get(0);
	}

	public List<String> getReferences(QName qname)
	{
		return references.get(qname);
	}
	
	public Object getExtension() 
	{
		return extension;
	}

	public void setExtension(Object extension) 
	{
		this.extension = extension;
	}
}
